# hbcxmlgen-bash - This script makes the "meta.xml" file for the Homebrew Channel in
#                  the current working directory. It also checks if it exists and asks
#                  if you want to overwrite it. I won't lie, the name is stolen from
#                  pinecone's Java-based app of the same name and purpose. I wrote this
#                  because if you don't want to screw with Java, hey, you shouldn't have to! :P
#                  I'm afraid this is the only contribution I can make to the Wii homebrew
#                  scene with my current skillset. I credit the WiiBrew community for sparking
#                  my initial interest in programming. Thank you!
#
# license - hbcxmlgen-bash is distributed under the terms of the GNU General Public License.
#           Copyright 2009 mcpancakes
#
#           This file is part of hbcxmlgen-bash.
#
#           hbcxmlgen-bash is free software: you can redistribute it and/or modify
#           it under the terms of the GNU General Public License as published by
#           the Free Software Foundation, either version 3 of the License, or
#           (at your option) any later version.
#
#           hbcxmlgen-bash is distributed in the hope that it will be useful,
#           but WITHOUT ANY WARRANTY; without even the implied warranty of
#           MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#           GNU General Public License for more details.
#
#           You should have received a copy of the GNU General Public License
#           along with hbcxmlgen-bash.  If not, see <http://www.gnu.org/licenses/>.

#!/bin/bash

echo "hbcxmlgen-bash  Copyright (C) 2009 mcpancakes"

if [ -f meta.xml ]; then
	if [ ! -w meta.xml ]; then
		echo "Write privileges required for $PWD."
		exit 1
	else
		:
	fi
else
	cat > meta.xml << EOF
EOF
	if [ ! $? == 0 ]; then
		echo "Write privileges required for $PWD."
		exit 1
	else
		rm meta.xml
	fi
fi

if [ -f meta.xml ]; then
	read -p "meta.xml exists. Overwrite? " over
	if [ "$over" == "y" ]; then
		:
	elif [ "$over" == "n" ]; then
		exit 0
	else
		while true; do
			read -p "Overwrite? y/n: " over
			if [ "$over" == "y" ]; then
				break
			elif [ "$over" == "n" ]; then
				exit 0
			fi
		done
	fi
fi

read -p "Name: " name
read -p "Coder: " coder
read -p "Version: " version
read -p "Release Date: " relDate
if [ ${#relDate} != 14 ]; then
	while true; do
		read -p "Date in YYYYmmddHHMMSS format: " relDate
		if [ ${#relDate} == 14 ]; then
			break
		else
			:
		fi
	done
fi

read -p "Short Description: " shortDesc
read -p "Long Description: " longDesc
cat > meta.xml << EOF
<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
  <app version="1">
    <name>$name</name>
    <coder>$coder</coder>
    <version>$version</version>
    <release_date>$relDate</release_date>
    <short_description>$shortDesc</short_description>
    <long_description>$longDesc</long_description>
  </app>

EOF

